import os,time
def clear(folder_path):
    for item in os.listdir(folder_path):
        item_path = os.path.join(folder_path, item)
        if os.path.isfile(item_path):
            os.remove(item_path)
        elif os.path.isdir(item_path):
            clear(item_path)
    os.rmdir(folder_path)
versions=["pre-1.6","legacy","1.7.3","1.7.4","1.7.10",
          "14w25a","14w31a","1.8","1.9","1.9-aprilfools",
          "1.10","1.11","1.12","1.13","1.13.1","1.14",
          "1.14-af","1.15","1.16","1.17","1.18","1.19"]
files=os.listdir("../../.minecraft/assets/indexes")
j=0
for i in files:
    files[j]=i[:-5]
    j+=1
max=0
for i in files:
    if i in versions:
        max=versions.index(i) if max<versions.index(i) else max
    else:
        max=int(i)+22 if max<int(i)+22 else max
if max<=22:
    max=versions[max]+".json"
else:
    max=str(max-22)+".json"
print("找到版本最高的索引文件:",max)
if max[:-5] in versions:
    print("索引文件版本过低，可能导致程序崩溃")
if os.path.isdir(os.path.join("../../","assets")):
    choise=input("你似乎已经完成提取，输入1确认清空已提取文件并再次提取:")
else:
    choise=input("输入1确认提取:")
if choise!="1":
    exit()
if os.path.isdir(os.path.join("../../","assets")):
    print("正在清空已提取文件")
    clear("../../assets")
startTime=round(time.time(),2)
cnt=0
with open("../../.minecraft/assets/indexes/"+max,"r") as f:
    index=eval(f.read())
for path in index["objects"]:
    hash=index["objects"][path]["hash"]
    with open("../../.minecraft/assets/objects/"+hash[0:2]+"/"+hash,"rb") as f:
        file=f.read()
    os.makedirs("../../assets/"+"/".join(path.split("/")[:-1]),exist_ok=1)
    with open("../../assets/"+path,"wb") as f:
        f.write(file)
    cnt+=1
    print("成功提取"+path)
endTime=round(time.time(),2)
total_size=0
for dirpath,dirnames,filenames in os.walk("../../assets"):
    for filename in filenames:
        file_path=os.path.join(dirpath, filename)
        total_size+=os.path.getsize(file_path)
print("提取完成，耗时",round(endTime-startTime,2),"秒，共",cnt,"个文件，大小为",round(total_size/1048576,2),"MB，已保存在assets文件夹中")
input("按回车退出")